# Configure WebSocket Support

You can configure an ALB to support WebSockets, a communication protocol that provides full-duplex communication channels over a single TCP connection.

To configure WebSocket support follow these steps:

1. [<mark style="color:blue;">Set up an ALB</mark>](https://docs.ionos.com/sections-test/guides/network-services/application-load-balancer/how-tos/setup-alb) either using the DCD or using the following API `POST` request.

```bash
curl -X POST -H ‘application/json’ -H ‘Authorization: Bearer ...’  https://api.ionos.com/cloudapi/v6/datacenters/{datacenterId}/applicationloadbalancers -d’
{
  “properties”: {
    “name”: “alb-websocket”,
    “listenerLan”: 1,
    “targetLan”: 2,
    “ips”: [“1.1.1.1”],
    “lbPrivateIps”: [“10.20.30.40/24”]
}
```

2. Create a Target Group.
   1. Before setting up an ALB, predefine a target group to distribute the incoming traffic to the correct target. An IP address and a port are used to register a target.
   2. Ensure that **no HTTP health check** is configured for the target group for WebSocket support. Otherwise the ALB targets will be unavailable for load balancing. TCP health checks, i.e. healthCheckEnabled, are allowed.
   3. You can either create target group using the [<mark style="color:blue;">Create a Target Group</mark>](https://docs.ionos.com/sections-test/guides/network-services/application-load-balancer/how-tos/create-target-groups) or the following `POST` request.

```bash
curl -X POST -H ‘application/json’ -H ‘Authorization: Bearer ...’  https://api.ionos.com/cloudapi/v6/targetgroups
{
  “properties”: {
    “name”: “websocket-target-group”,
    “algorithm”: “ROUND_ROBIN”,
    “protocol”: “HTTP”,
    “targets”: [
      {
        “ip”: “10.20.30.100”,
        “port”: 8080,
        “weight”: 10,
        “healthCheckEnabled”: true
      }
    ]
}
```

3. Create a [<mark style="color:blue;">Forwarding rule</mark>](https://docs.ionos.com/sections-test/guides/network-services/application-load-balancer/setup-alb#add-forwarding-rules).

Forwarding rules define how client traffic is distributed to the targets. More than one rule can be created for the same load balancer.

Forwarding rule example:

```json
{
  “properties”: {
    “name”: “websocket-rule”,
    “protocol”: “HTTP”,
    “listenerIp”: “1.2.3.4”,
    “listenerPort”: 80,
    “httpRules”: [
      {
        “name”: “forward”,
        “type”: “FORWARD”,
        “targetGroup”: “<target group id>”
      }
    ]
}
```

{% hint style="info" %}
**Note**: Web Socket traffic is not normal HTTP traffic, so ensure that your HTTP rules or conditions are accurate. Only the initial protocol upgrade to enable Web Socket tunneling can be targeted by the HTTP rule conditions. An example of this would be:
{% endhint %}

```json
{
 “httpRules”: [
      {
        “name”: “forward”,
        “type”: “FORWARD”,
        “targetGroup”: “<target group ID>“,
        “conditions”: [
          {
            “type”: “HEADER”,
            “condition”: “EQUALS”,
            “key”: “Connection”,
            “value”: “upgrade”
          },
          {
            “type”: “HEADER”,
            “condition”: “EQUALS”,
            “key”: “Upgrade”,
            “value”: “websocket”
          }
        ]
      }
    ]
}
```

{% hint style="success" %}
\*\*Result:\*\* This should result in an ALB that is able to handle HTTP protocol upgrade requests to switch to Web Socket tunneling.
{% endhint %}
